<!DOCTYPE html>
<html lang="en">
  <head>
    <meta charset="utf-8">
    <title>uWeaver UI - API documentation : Source: widget/TabPanel.js</title>

    <script src="scripts/prettify/prettify.js"> </script>
    <script src="scripts/prettify/lang-css.js"> </script>
    <!--[if lt IE 9]>
      <script src="//html5shiv.googlecode.com/svn/trunk/html5.js"></script>
    <![endif]-->
    <link type="text/css" rel="stylesheet" href="styles/prettify-tomorrow.css">
    <link href="styles/bootstrap.css" rel="stylesheet">
    <link href="styles/docs.css" rel="stylesheet">
    <link href="styles/bootstrap-custom.css" rel="stylesheet">
    <link href="http://netdna.bootstrapcdn.com/font-awesome/3.2.1/css/font-awesome.css" rel="stylesheet">
    <script src="http://netdna.bootstrapcdn.com/twitter-bootstrap/2.3.2/js/bootstrap.min.js"></script>
  </head>
  <body>
    <header class="header navbar navbar-inverse">
      <div class="navbar-inner">
        <div class="container-fluid">
          <a class="brand" href="#"><strong>uWeaver UI</strong> API documentation</a>
        </div>
      </div>
    </header>

    <div class="container-fluid">
      <div class="row-fluid">
          <div class="span4">
              <h2><a href="index.html">Index</a></h2><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Modules</li><li><a href="module-boolean.html">boolean</a></li>
<li><a href="module-datetime.html">datetime</a></li>
<li><a href="module-dom.html">dom</a></li>
<li><a href="module-environment.html">environment</a></li>
<li><a href="module-formatter.html">formatter</a></li>
<li><a href="module-i18n.html">i18n</a></li>
<li><a href="module-lang.html">lang</a></li>
<li><a href="module-net.html">net</a></li>
<li><a href="module-number.html">number</a></li>
<li><a href="module-uweaver.html">uweaver</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Classes</li><li><a href="Activities.html"><i class="icon-shield" style="color: #0186d1"></i> Activities</a></li><li><a href="Activity.html"><i class="icon-shield" style="color: #0186d1"></i> Activity</a></li><li><a href="Applet.html"><i class="icon-shield" style="color: #0186d1"></i> Applet</a></li><li><a href="BaseObject.html"><i class="icon-shield" style="color: #0186d1"></i> BaseObject</a></li><li><a href="Button.html"><i class="icon-shield" style="color: #0186d1"></i> Button</a></li><li><a href="CartesianChart.html"><i class="icon-shield" style="color: #0186d1"></i> CartesianChart</a></li><li><a href="Checkbox.html"><i class="icon-shield" style="color: #0186d1"></i> Checkbox</a></li><li><a href="Collection.html"><i class="icon-shield" style="color: #0186d1"></i> Collection</a></li><li><a href="Combobox.html"><i class="icon-shield" style="color: #0186d1"></i> Combobox</a></li><li><a href="Container.html"><i class="icon-shield" style="color: #0186d1"></i> Container</a></li><li><a href="Datebox.html"><i class="icon-shield" style="color: #0186d1"></i> Datebox</a></li><li><a href="Datepicker.html"><i class="icon-shield" style="color: #0186d1"></i> Datepicker</a></li><li><a href="Filebox.html"><i class="icon-shield" style="color: #0186d1"></i> Filebox</a></li><li><a href="Filedropper.html"><i class="icon-shield" style="color: #0186d1"></i> Filedropper</a></li><li><a href="Form.html"><i class="icon-shield" style="color: #0186d1"></i> Form</a></li><li><a href="Gadget.html"><i class="icon-shield" style="color: #0186d1"></i> Gadget</a></li><li><a href="Grid.html"><i class="icon-shield" style="color: #0186d1"></i> Grid</a></li><li><a href="Icon.html"><i class="icon-shield" style="color: #0186d1"></i> Icon</a></li><li><a href="Inputbox.html"><i class="icon-shield" style="color: #0186d1"></i> Inputbox</a></li><li><a href="Item.html"><i class="icon-shield" style="color: #0186d1"></i> Item</a></li><li><a href="Json.html"><i class="icon-shield" style="color: #0186d1"></i> Json</a></li><li><a href="Logger.html"><i class="icon-shield" style="color: #0186d1"></i> Logger</a></li><li><a href="MDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> MDIApplet</a></li><li><a href="Memory.html"><i class="icon-shield" style="color: #0186d1"></i> Memory</a></li><li><a href="Menu.html"><i class="icon-shield" style="color: #0186d1"></i> Menu</a></li><li><a href="Model.html"><i class="icon-shield" style="color: #0186d1"></i> Model</a></li><li><a href="Numberbox.html"><i class="icon-shield" style="color: #0186d1"></i> Numberbox</a></li><li><a href="Pagination.html"><i class="icon-shield" style="color: #0186d1"></i> Pagination</a></li><li><a href="Panel.html"><i class="icon-shield" style="color: #0186d1"></i> Panel</a></li><li><a href="PolarChart.html"><i class="icon-shield" style="color: #0186d1"></i> PolarChart</a></li><li><a href="Popup.html"><i class="icon-shield" style="color: #0186d1"></i> Popup</a></li><li><a href="Portal.html"><i class="icon-shield" style="color: #0186d1"></i> Portal</a></li><li><a href="Proxy.html"><i class="icon-shield" style="color: #0186d1"></i> Proxy</a></li><li><a href="Radiobutton.html"><i class="icon-shield" style="color: #0186d1"></i> Radiobutton</a></li><li><a href="Reader.html"><i class="icon-shield" style="color: #0186d1"></i> Reader</a></li><li><a href="Selectbox.html"><i class="icon-shield" style="color: #0186d1"></i> Selectbox</a></li><li><a href="Site.html"><i class="icon-shield" style="color: #0186d1"></i> Site</a></li><li><a href="Sites.html"><i class="icon-shield" style="color: #0186d1"></i> Sites</a></li><li><a href="Store.html"><i class="icon-shield" style="color: #0186d1"></i> Store</a></li><li><a href="TabPanel.html"><i class="icon-shield" style="color: #0186d1"></i> TabPanel</a></li><li><a href="TDIApplet.html"><i class="icon-shield" style="color: #0186d1"></i> TDIApplet</a></li><li><a href="Testbench.html"><i class="icon-shield" style="color: #0186d1"></i> Testbench</a></li><li><a href="Testlet.html"><i class="icon-shield" style="color: #0186d1"></i> Testlet</a></li><li><a href="Textbox.html"><i class="icon-shield" style="color: #0186d1"></i> Textbox</a></li><li><a href="Toolbox.html"><i class="icon-shield" style="color: #0186d1"></i> Toolbox</a></li><li><a href="Trigger.html"><i class="icon-shield" style="color: #0186d1"></i> Trigger</a></li><li><a href="Triggers.html"><i class="icon-shield" style="color: #0186d1"></i> Triggers</a></li><li><a href="User.html"><i class="icon-shield" style="color: #0186d1"></i> User</a></li><li><a href="Users.html"><i class="icon-shield" style="color: #0186d1"></i> Users</a></li><li><a href="Violation.html"><i class="icon-shield" style="color: #0186d1"></i> Violation</a></li><li><a href="Widget.html"><i class="icon-shield" style="color: #0186d1"></i> Widget</a></li><li><a href="WindowManager.html"><i class="icon-shield" style="color: #0186d1"></i> WindowManager</a></li><li><a href="Workbench.html"><i class="icon-shield" style="color: #0186d1"></i> Workbench</a></li></ul></div><div class="well well-small"><ul class="nav nav-list"><li class="nav-header">Global</li><li><a href="global.html#_anchors"><i class="icon-globe" style="color: black;"></i> _anchors</a></li><li><a href="global.html#_form"><i class="icon-globe" style="color: black;"></i> _form</a></li><li><a href="global.html#_interact"><i class="icon-globe" style="color: black;"></i> _interact</a></li><li><a href="global.html#_marker"><i class="icon-globe" style="color: black;"></i> _marker</a></li><li><a href="global.html#_tabPanel"><i class="icon-globe" style="color: black;"></i> _tabPanel</a></li><li><a href="global.html#browse"><i class="icon-globe" style="color: black;"></i> browse</a></li><li><a href="global.html#draggable"><i class="icon-globe" style="color: black;"></i> draggable</a></li><li><a href="global.html#events"><i class="icon-globe" style="color: black;"></i> events</a></li><li><a href="global.html#initialize"><i class="icon-globe" style="color: black;"></i> initialize</a></li><li><a href="global.html#layout"><i class="icon-globe" style="color: black;"></i> layout</a></li><li><a href="global.html#logger"><i class="icon-globe" style="color: black;"></i> logger</a></li><li><a href="global.html#login"><i class="icon-globe" style="color: black;"></i> login</a></li><li><a href="global.html#onDragstart"><i class="icon-globe" style="color: black;"></i> onDragstart</a></li><li><a href="global.html#onTabsActivate"><i class="icon-globe" style="color: black;"></i> onTabsActivate</a></li><li><a href="global.html#onTaskSelect"><i class="icon-globe" style="color: black;"></i> onTaskSelect</a></li><li><a href="global.html#perform"><i class="icon-globe" style="color: black;"></i> perform</a></li><li><a href="global.html#prepare"><i class="icon-globe" style="color: black;"></i> prepare</a></li><li><a href="global.html#requirejs"><i class="icon-globe" style="color: black;"></i> requirejs</a></li><li><a href="global.html#start"><i class="icon-globe" style="color: black;"></i> start</a></li><li><a href="global.html#toUrl"><i class="icon-globe" style="color: black;"></i> toUrl</a></li><li><a href="global.html#validate"><i class="icon-globe" style="color: black;"></i> validate</a></li></ul></div>
          </div>

          <div class="span8">
              <h1 class="page-header">Source: widget/TabPanel.js</h1>
              


    
    <section>
        <article>
            <pre class="prettyprint source"><code>/**
 * @license
 * This document is a part of the source code and related artifacts
 * for uWeaver, an open source application development framework for
 * Enterprise Application Software.
 *
 *      http://www.uweaver.org
 *
 * Copyright 2014 Jason Lin
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

define(['underscore', 'jquery', 'uweaver/lang',
    'uweaver/widget/Container', 'uweaver/string', 'uweaver/widget/Widget',
    'text!./tpl/TabPanel.html',
    'uweaver/exception/UnsupportedTypeException',
    'uweaver/Logger'], function(_, $, lang, Container, string, Widget, tpl, UnsupportedTypeException, Logger) {

    var declare = lang.declare;
    var Base = Container;
    var LOGGER = new Logger("uweaver/widget/TabPanel");

    /**
     * A TabPanel is a tabbed container.
     *
     * ##### Usage
     *     var panel = new TabPanel({
     *         el: $('#panel')
     *     });
     *     panel.render();
     *
     *     var $node = $('&lt;h3>Messages&lt;/h3>&lt;p>Here are messages for you ...&lt;/p>');
     *     panel.add($node, {
     *         title: "Messages"
     *     });
     *
     *     var widget = new Widget({
     *         tpl: '&lt;h3>Preferences&lt;/h3>&lt;p>Here are your personal preferences ...&lt;/p>'
     *     }).render();
     *
     *     panel.add(widget, {
     *         title: "Preferences"
     *     });
     *
     *
     * ##### Template
     *      &lt;!-- Tabs dom -->
     *      &lt;!-- the following dom are required.
     *      * ul.nav - contains all the tabs.
     *      * ul.nav > li - a tab.
     *      * ul.nav > li.active - the active tab.
     *      * ul.nav > li > a[data-toggle="tab"] - the link to trigger the transition. href reference the name or id of the tab pane. Name is recommended.
     *      -->
     *      &lt;ul class="nav nav-tabs" role="tablist">
     *          &lt;li class="active">&lt;a href="#home" data-toggle="tab">Home&lt;/a>&lt;/li>
     *          &lt;li>&lt;a href="#profile"  data-toggle="tab">Profile&lt;/a>&lt;/li>
     *      &lt;/ul>
     *     &lt;!-- Tab Panes dom -->
     *     &lt;!-- the following dom are required.
     *     * div.tab-content - contains all the tab panes.
     *     * div.tab-content > div.tab-pane - a tab pane. The name or id attribute is required.
     *     * div.tab-content > div.tab-pane.active - the active tab pane.
     *     -->
     *     &lt;div class="tab-content">
     *         &lt;div class="tab-pane active" name="home">
     *             &lt;h3>Home&lt;/h3>
     *             &lt;p>This is your home page.&lt;/p>
     *         &lt;/div>
     *         &lt;div class="tab-pane" name="profile">
     *              &lt;h3>Profile&lt;/h3>
     *              &lt;p>Your profile info goes here ...&lt;/p>
     *         &lt;/div>
     *      &lt;/div>
     *
     * ##### Events:
     * + 'select' - [select()]{@link TabPanel#select}, [add()]{@link TabPanel#add}, [remove()]{@link TabPanel#remove}
     * + 'selected' - [select()]{@link TabPanel#select}, [add()]{@link TabPanel#add}, [remove()]{@link TabPanel#remove}
     * + 'add' - [add()]{@link TabPanel#add}
     * + 'remove' - [remove()]{@link TabPanel#remove}
     *
     * @constructor TabPanel
     * @extends Widget
     * @author  Jason Lin
     * @since   1.0
     * @param {Object} [config] - A map of configuration to pass to the constructor.
     * @param {String} [config.tpl] - A html string to layout &amp; construct the DOM element.
     */
    function initialize(config) {
        Base.prototype.initialize.apply(this, arguments);

        var defaults = {};
        var cfg = this._cfg;

        _.defaults(cfg, defaults);

        this._anchors = {
            $navbar: undefined,
            $content: undefined
        };

        this._components = [];
        this._indexes = {};

        cfg.tpl || (cfg.tpl = tpl);
    }

    /**
     * @override
     */
    function render(options) {
        Base.prototype.render.apply(this, arguments);

        var defaults = {
            hidden: false
        };
        var cfg = this._cfg;
        var anchors = this._anchors;

        options || (options = {});
        _.defaults(options, defaults);

        anchors.$navbar = this.$('ul.nav').first();
        anchors.$content = this.$('div.tab-content').first();

        // assumption: there should be the same # of tabs &amp; tabpane.
        // 1. generate id for those tabpanes without id.
        // 2. rewrite the href for those tabs link to the name.
        var $tabpanes = anchors.$content.find('> .tab-pane');
        _.each($tabpanes, function(tabpane){
            var $tabpane = $(tabpane);
            if(!$tabpane.prop('id') &amp;&amp; $tabpane.attr('name')) {
                $tabpane.prop('id', _.uniqueId());
                var href = '#' + $tabpane.prop('id');
                var links = anchors.$navbar.find("> li >a[href='#" + $tabpane.attr('name') + "']");
                $(links).attr('href', href);
            }
        }, this);

        var components = this._components;
        var indexes = this._indexes;
        var $links = anchors.$navbar.find('> li > a');
        _.each($links, function(link) {
            var $link = $(link);
            var id = $link.attr('href').substring(1);
            var tabpane = this.$('#' + id)[0];

            var component = (tabpane) ? tabpane.childNodes : undefined;
            components.push(component);
            indexes[id] = component;
        }, this);

        $links.on('click', _.bind(onTabClick, this));

        if(this.render === render) {
            this._isRendered = true;

            this.trigger('render', {
                data: {},
                context: this,
                source: this
            });
            options.hidden || this._components.length===0 || this.show();
        }

        return this;
    }

    function onTabClick(e) {
        e.preventDefault();
        var id = $(e.currentTarget).attr('href').substring(1);
        var component = this._indexes[id];

        this.select(component);

    }

    /**
     * Add the component to the TabPanel.
     *
     * ##### Events:
     * + 'add' - triggered after added. event.data => the added component.
     * + 'select' - triggered before new component selected.
     * + 'selected' - triggered after new component selected.
     *
     * @memberof TabPanel#
     * @param {Widget|jQuery|NodeList} component - The component to add.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {String} [options.title] - A text to specify the caption displayed in the tab.
     * @param {String} [options.icon] - A string to specify the icon displayed in the tab.
     * @param {String} [options.badge] - A text to specify the symbol displayed in the tab.
     * @param {Boolean} [options.closable=false] - A true value to display a close button in the tab.
     * @param {Boolean} [options.selected=true] - A false value to prevent the new tabpane from being selected.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @param {Integer} [options.index] - index at which the specified component is to be inserted.
     * @returns {TabPanel} this
     */
    function add(component, options) {
        if(component===undefined) return this;

        options || (options = {});

        var defaults = {
            closable: false,
            selected: true
        };

        _.defaults(options, defaults);

        var anchors = this._anchors;

        var tab = "&lt;li>&lt;a href='#${id}' data-toggle='tab'>${icon}${title}&lt;span class='badge' style='margin-left:3px;'>${badge}&lt;/span>${close}&lt;/a>&lt;/li>";
        var tabpane = "&lt;div  class='tab-pane' id='${id}'>&lt;/div>";
        var close = (options.closable) ? "&lt;i class='fa fa-close' style='position:relative;top: -10px;left: 10px;'>&lt;/i>" : "";
        var icon = (options.icon) ? "&lt;i class='fa fa-" + options.icon + "' style='padding-right: 5px'>&lt;/i>" : "";

        var args = {
            id: _.uniqueId(),
            title: options.title,
            badge: (options.badge) || "",
            close: close,
            icon: icon
        };

        var $tab = $(string.substitute(tab, args));
        var $tabpane = $(string.substitute(tabpane, args));

        if(component instanceof Widget) {
            component.attach($tabpane);
        } else if(component instanceof jQuery) {
            $tabpane.append(component);
        } else if(component instanceof NodeList) {
            $tabpane.append($(component));
        } else {
            throw new UnsupportedTypeException({
                supportedTypes: ['Widget', 'jQuery', 'NodeList'],
                type: typeof component
            });
        }

        if(options.index!==undefined &amp;&amp; this.size()>=0) {
            var index = options.index;
            var $tabs = anchors.$navbar.find('>li');
            $tab.insertBefore($tabs.eq(index));
            this._components.splice(index, 0, component);
        } else {
            anchors.$navbar.append($tab);
            this._components.push(component);
        }

        anchors.$content.append($tabpane);

        $tab.find('> a').on('click', _.bind(onTabClick, this));

        $tab.find('> a > i.fa-close').on('click', _.bind(onCloseClick, this));

        this._indexes[$tabpane.prop('id')] = component;

        if(options.selected || this.size()===1) {
            this.select(component, options);
        }

        options.silent || this.trigger('add', {
            data: {},
            context: this,
            source: this
        });

        this.isVisible() || this.show();

        return this;
    }

    function onCloseClick(event) {
        event.preventDefault();
        var target = event.target;
        var id = $(target).parent().attr('href').substring(1);
        var component = this._indexes[id];
        this.remove(component);
    }

    /**
     * Remove the component from the TabPanel.
     *
     * ##### Events:
     * + 'remove'- triggered after removed. event.data => the removed component.
     * + 'select' - triggered before new component selected.
     * + 'selected' - triggered after selected.
     *
     * @memberof TabPanel#
     * @param {Widget|jQuery|NodeList} component - The component to remove.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @returns {TabPanel} this
     */
    function remove(component, options) {
        if(component===undefined) return this;

        options || (options = {});

        var anchors = this._anchors;
        var index = _.isNumber(component) ? component : _.findIndex(this._components, function(n) {
            return n === component;
        });

        var $tab = $(anchors.$navbar.find('> li')[index]);
        var id = $tab.find('>a').attr('href').substring(1);
        var $tabpane = anchors.$content.find('> div.tab-pane#'+id);
        var isActive = $tab.hasClass('active');

        this._components.splice(index, 1);
        delete this._indexes[$tabpane.prop('id')];

        this.hide();

        $tabpane.remove();
        $tab.remove();

        if(this.size()>0) {
            if(isActive) {
                this.select(Math.max(0, index-1), options);
            }
            this.show();
        }

        options.silent || this.trigger('remove', {
            data: {},
            context: this,
            source: this
        });

        return this;
    }

    /**
     * Remove all components from the TabPanel.
     *
     * ##### Events:
     * + 'remove'- triggered after removed. event.data => the removed component.
     *
     * @memberof TabPanel#
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @returns {TabPanel} this
     */
    function removeAll(options) {
        options || (options = {});

        var anchors = this._anchors;

        this.hide();

        _.each(anchors.$navbar.find('> li'), function(tab){
            var $tab = $(tab);
            var id = $tab.find('>a').attr('href').substring(1);
            var $tabpane = anchors.$content.find('> div.tab-pane#'+id);
            $tabpane.remove();
            $tab.remove();
        });

        this._components = [];
        this._indexes = {};

        options.silent || this.trigger('remove', {
            data: {},
            context: this,
            source: this
        });
    }

    /**
     * Get the component.
     *
     * @memberof TabPanel#
     * @param {Integer} index - The index of component. zero-based.
     * @returns {Widget|jQuery|NodeList}
     */
    function get(index) {
        return this._components[index];
    }

    /**
     * Select the component to show(make it active).
     *
     * ##### Events:
     * + 'select' - triggered before selected.
     * + 'selected' - triggered after selected.
     *
     * @memberof TabPanel#
     * @param {Widget|jQuery|NodeList|Integer} component - The component(or index of the component) to show.
     * @param {Object} [options] - A map of additional options to pass to the method.
     * @param {Boolean} [options.silent=false] - A true value will prevent the events from being triggered.
     * @returns {TabPanel} this
     */
    function select(component, options) {
        if(component===undefined) return this;

        options || (options = {});
        var anchors = this._anchors;

        var index = _.isNumber(component) ? component : _.findIndex(this._components, function(n) {
            return n === component;
        });

        (options.silent) || this.trigger("select", {
            context: this,
            source: this,
            data: this._components[index]
        });


        anchors.$navbar.find('>li').removeClass('active');
        anchors.$content.find('>div.tab-pane').hide();

        var $tab = $(anchors.$navbar.find('> li')[index]);
        var id = $tab.find('>a').attr('href').substring(1);
        var $tabpane = anchors.$content.find('> div.tab-pane#'+id);
        $tab.addClass('active');
        $tabpane.show();

        (options.silent) || this.trigger("selected", {
            context: this,
            source: this,
            data: this._components[index]
        });

        return this;
    }

    /**
     * Get the active component.
     *
     * @memberof TabPanel#
     * @returns {Widget|jQuery|NodeList}
     */
    function current() {
        var anchors = this._anchors;

        var $links = anchors.$navbar.find('>li>a');
        var link = _.find(_.toArray($links), function(link) {
            return $(link).parent().hasClass('active');
        });

        var id = link.getAttribute('href').substring(1);

        return this._indexes[id];
    }

    /**
     * Get the # of components.
     *
     * @memberof TabPanel#
     * @returns {Integer}
     */
    function size() {
        return this._components.length;
    }

    /**
     *
     * Get the current tab's title.
     *
     * @memberof TabPanel#
     * @returns {String}
     */
    function title() {
        var anchors = this._anchors;

        var $links = anchors.$navbar.find('> li a');
        var link = _.find(_.toArray($links), function(link) {
            return $(link).parent().hasClass('active');
        });

        var textNode = _.first($(link).contents().filter(function(){return this.nodeType===3;}));

        return textNode.textContent;

    }
    
    function badge(component, text) {
        var anchors = this._anchors;
        var index = _.isNumber(component) ? component : _.findIndex(this._components, function(n) {
            return n === component;
        });

        var $tab = $(anchors.$navbar.find('> li')[index]);
        var $badge = $tab.find('.badge');
        
        
        if(text===undefined) return $badge.text();
        
        $badge.text(text);
    }

    /**
     *
     * Get all components.
     *
     * @memberof TabPanel#
     * @returns {String}
     */
    function components() {
        return this._components;
    }

    var props = {
        _anchors: undefined,
        _components: undefined,
        _indexes: undefined
    };

    var TabPanel = declare(Base, {
        initialize: initialize,
        render: render,

        add: add,
        remove: remove,
        removeAll: removeAll,
        select: select,
        get: get,
        current: current,
        size: size,
        title: title,
        badge: badge,
        components: components
    }, props);

    return TabPanel;
});
</code></pre>
        </article>
    </section>




          </div>
      </div>

        <br clear="both">

      <footer>
        Documentation generated by <a href="https://github.com/jsdoc3/jsdoc">JSDoc 3.3.2</a> on Fri Aug 26 2016 10:58:19 GMT+0800 (CST)
        <br>
      </footer>
      <script> prettyPrint(); </script>
    </div>
  </body>
</html>
